{ File opening procedure.

Directions for use:
   Declare OPEN_OUT as a forward reference in calling program:
      function OPEN_OUT (var outf: text;
                               var fname: fstring): boolean; forward;
   & follow immediately with an include directive.
   This permits declaring outf & fname as any desired type.

   Returns FALSE if user gave null string as file name; this
     permits no-output option if desired.
                                                                        }

function OPEN_OUT;
   var _reply: string[16];
       _accept: boolean;
   begin
   repeat
      write ('Output File: ');
      readln (fname);
      if fname = '' then
         _accept := true
      else
         begin
{$I-}
         assign (outf, fname);
         reset (outf);
{$I+}
         _accept := ioresult <> 0;
         if not _accept then
            begin
            write ('File already exists.  Okay to overwrite? ');
            readln (_reply);
            _accept := (length(_reply) > 0) and (_reply[1] in ['y', 'Y'])
            end;
         end;
   until _accept;
   if fname = '' then
      open_out := false
   else
      begin
{$I-}
      close (outf);
{$I+}
      if ioresult <> 0 then ;
      rewrite (outf);
      open_out := true
      end;
   end;
